// FindSameFilesDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FindSameFiles.h"
#include "FindSameFilesDlg.h"
#include "LinkText.h"
#include <io.h>
#include <direct.h>
#include <sys/stat.h>
#pragma warning (disable : 4786)
#include <string>
#include <list>
#include <map>
using namespace std;

const char* CFindSameFilesDlg::s_settingFileName = "FindSameFiles.txt";

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CLinkText	m_link;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LINK, m_link);
	//}}AFX_DATA_MAP
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString	s;
	s.Format("FindSameFiles Version %.2f",CFindSameFilesApp::s_appVersion * 0.01);
	GetDlgItem(IDC_VERSION)->SetWindowText(s);
	return TRUE;
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindSameFilesDlg _CAO

CFindSameFilesDlg::CFindSameFilesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFindSameFilesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFindSameFilesDlg)
	m_dir = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFindSameFilesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindSameFilesDlg)
	DDX_Control(pDX, IDC_LIST, m_list);
	DDX_Text(pDX, IDC_DIR, m_dir);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFindSameFilesDlg, CDialog)
	//{{AFX_MSG_MAP(CFindSameFilesDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_REF, OnRef)
	ON_LBN_DBLCLK(IDC_LIST, OnDblclkList)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_WM_DROPFILES()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_DELALL, OnDelall)
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindSameFilesDlg bZ[W nh

void ChExeDir()
{
	char	buf[512],*p;
	GetModuleFileName(0,buf,sizeof(buf));
	p = strrchr(buf,'\\');
	if (p) *p = 0;
	chdir(buf);
}

BOOL CFindSameFilesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	m_lay.SetType(GetDlgItem(IDOK),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDCANCEL),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_DEL),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_DELALL),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_EDIT),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_REF),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_OPEN),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_DIR),CLayoutManager::FreeSize,CLayoutManager::Default);
	m_lay.SetType(&m_list,CLayoutManager::FreeSize,CLayoutManager::FreeSize);
	m_lay.Reset();
	ChExeDir();
	FILE* f = fopen(s_settingFileName,"r");
	if (f) {
		char	buf[512],*p;
		int		x,y,ver;
		fgets(buf,sizeof(buf),f);
		sscanf(buf,"%d",&ver);
		fgets(buf,sizeof(buf),f);
		if (sscanf(buf,"%d %d",&x,&y) == 2) {
			SetWindowPos(0,0,0,x,y,SWP_NOMOVE);
		}
		fgets(buf,sizeof(buf),f);
		p = strrchr(buf,'\n');
		if (p) *p = 0;
		m_dir = buf;
		fclose(f);
		UpdateData(FALSE);
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CFindSameFilesDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CFindSameFilesDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CFindSameFilesDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFindSameFilesDlg::OnDestroy() 
{
	CRect		r;
	CString		s;
	ChExeDir();
	FILE* f = fopen(s_settingFileName,"w");
	if (f) {
		GetWindowRect(&r);
		fprintf(f,"%d\n%d %d\n%s\n",CFindSameFilesApp::s_appVersion,
			r.Width(),r.Height(),(const char*)m_dir);
		fclose(f);
	}
	CDialog::OnDestroy();
}

void CFindSameFilesDlg::OnRef() 
{
	char	buf[MAX_PATH];
	if (!UpdateData()) return;
	strcpy(buf,m_dir);
	if (FolderDlg(this->m_hWnd,"fBNgݒ",buf))
		return;
	m_dir = buf;
	UpdateData(FALSE);
}

void CFindSameFilesDlg::OnOpen() 
{
	if (!UpdateData()) return;
	ShellExecute(m_hWnd,"open",m_dir,0,0,SW_SHOW);
}

void CFindSameFilesDlg::OnDblclkList() 
{
	int		k, i = m_list.GetCurSel();
	if (i == LB_ERR) {
		MB("sIĉ");
		return;
	}
	CString	s,t;
	m_list.GetText(i,s);
	k = s.Find('/');
	if (k == -1) return;
	t = s.Left(k+1);
	t = s.Right(s.GetLength() - k - 1) + t;
	m_list.DeleteString(i);
	m_list.InsertString(i,t);
	m_list.SetCurSel(i);
}

bool CFindSameFilesDlg::DelLine(int i)
{
	int		k,pre;
	bool	bErr = false;
	char	buf[512];
	SHFILEOPSTRUCT	fo;
	fo.hwnd = m_hWnd;
	fo.wFunc = FO_DELETE;
	fo.pFrom = buf;
	fo.pTo = 0;
	fo.fFlags = FOF_ALLOWUNDO | FOF_NOCONFIRMATION | FOF_NOERRORUI;
	CString	s,t;
	m_list.GetText(i,s);
	k = s.Find('/');
	if (k != -1) while ((k = s.Find('/',pre = k + 1)) != -1) {
		t = s.Mid(pre,k-pre);
		strcpy(buf,m_dir + "\\" + t);
		buf[strlen(buf)+1] = 0;
		if (SHFileOperation(&fo)) bErr = true;
//		if (unlink(t)) bErr = true;
	}
	return bErr;
}

void CFindSameFilesDlg::OnDel() 
{
	int		i = m_list.GetCurSel();
	if (i == LB_ERR) {
		MB("sIĉ");
		return;
	}
	if (DelLine(i))
		MB("t@C폜ł܂");
	else m_list.DeleteString(i);
}

void CFindSameFilesDlg::OnDelall() 
{
	int			i, n = m_list.GetCount();
	if (!n) {
		MB("폜̂܂");
		return;
	}
	if (MB("S폜܂H",MB_YESNO) != IDYES) return;
	CWaitCursor	dummy;
	bool		bErr = false;
	for (i=0;i<n;) {
		if (DelLine(i)) {
			bErr = true;
			++i;
		} else {
			m_list.DeleteString(i);
			--n;
		}
	}
	if (bErr) MB("폜łȂ̂܂");
}

void CFindSameFilesDlg::OnEdit() 
{
	int		k, i = m_list.GetCurSel();
	if (i == LB_ERR) {
		MB("sIĉ");
		return;
	}
	CString	s,t;
	m_list.GetText(i,s);
	k = s.Find('/');
	if (k == -1) return;
	t = s.Left(k);
	ShellExecute(m_hWnd,"open",t,0,0,SW_SHOW);
}

void CFindSameFilesDlg::OnDropFiles(HDROP hDropInfo) 
{
	int		n;
	char	buf[MAX_PATH+1];
	if (!UpdateData()) return;
	n = ::DragQueryFile(hDropInfo,0xffffffff,buf,sizeof(buf)-1);
	if (n != 1) return;
	::DragQueryFile(hDropInfo,0,buf,sizeof(buf)-1);
	m_dir = buf;
	UpdateData(FALSE);
	::DragFinish(hDropInfo);
}

void CFindSameFilesDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if (nType == 0 || nType == 2) m_lay.Layout();
}

bool CheckSameFile(const char* fnam1,const char* fnam2)
{
	FILE*	f1 = fopen(fnam1,"rb");
	if (!f1) return false;
	FILE*	f2 = fopen(fnam2,"rb");
	if (!f2) {
		fclose(f1);
		return false;
	}
	bool	b = true;
	int		c1,c2;
	while ((c1 = getc(f1)) != EOF) {
		c2 = getc(f2);
		if (c2 != c1) {
			b = false;
			break;
		}
	}
	fclose(f2);
	fclose(f1);
	return b;
}

list<CString> GetSameFiles(list<pair<string,bool> >& l)
{
	list<CString>	ll;
	CString			s;
	bool			b;
	list<pair<string,bool> >::iterator	lit,it;
	it = l.begin();
	if (it != l.end()) while (true) {
		pair<string,bool>& pr = *it;
		if (++it == l.end()) break;
		if (pr.second) continue;
		s = CString(pr.first.c_str()) + "/";
		b = false;
		lit = it;
		while (lit != l.end()) {
			if (CheckSameFile(pr.first.c_str(),lit->first.c_str())) {
				lit->second = b = true;
				s += CString(lit->first.c_str()) + "/";
			}
			++lit;
		}
		if (b) ll.push_back(s);
	}
	return ll;
}

void CFindSameFilesDlg::OnOK() 
{
	if (!UpdateData()) return;
	if (chdir(m_dir)) {
		MB("fBNg " + m_dir + " Ɉړł܂");
		return;
	}
	map<int,list<pair<string,bool> > >	mp;
	map<int,list<pair<string,bool> > >::iterator	it;
	pair<string,bool>		pr("",false);
	list<CString>::iterator	lit;
	_finddata_t	fd;
	long		h;
	if ((h = _findfirst("*.*",&fd)) == -1L) {
		MB("t@CP܂");
		return;
	}
	struct stat	st;
	do {
		if (!stat(fd.name,&st) && !(st.st_mode & S_IFDIR)) {
			pr.first = fd.name;
			mp[st.st_size].push_back(pr);
		}
	} while (_findnext(h,&fd) == 0);
	_findclose(h);
	m_list.ResetContent();
	for (it=mp.begin();it!=mp.end();++it) {
		list<pair<string,bool> >& l = it->second;
		if (l.size() == 1) continue;
		list<CString>	ll = GetSameFiles(l);
		for (lit=ll.begin();lit!=ll.end();++lit)
			m_list.AddString(*lit);
	}
	if (m_list.GetCount() == 0)
		MB("̂͂܂");
	else m_list.SetCurSel(0);
}
